#   (c) by zucKi    http://ircbot.bf-scene.de
#
#   This class helps you to get the actual played time
#   in this round.
#
#   DONT MODIFY THIS FILE
#   You are free to use this class for your modules
#   You are not allowed to distribute this file with your modules
###################################################################


import host
import bf2

class TimeElapsed(object):

    def __init__(self):
        self.startTime = 0
        self.pausedTime = 0
        self.pausedFor = 0
        self.startDelay = 0
        
        #register handler
        host.registerGameStatusHandler(self.onGameStatusChanged)

    def __start(self):
        self.startTime = host.timer_getWallTime()
        self.startDelay = int(host.rcon_invoke("sv.startDelay"))
        self.pausedTime = 0
        self.pausedFor = 0

    def __reset(self):
        self.startTime = 0
        self.pausedTime = 0
        self.pausedFor = 0

    def __pause(self):
        if not self.pausedTime:
            self.pausedTime = host.timer_getWallTime()

    def __unpause(self):
        if self.pausedTime:
            self.pausedFor += host.timer_getWallTime() - self.pausedTime
            self.pausedTime = 0

    def isPaused(self):
        if self.pausedTime:
            return 1
        else:
            return 0

    def getTime(self):
        if self.startTime:
            return int(host.timer_getWallTime() - self.startTime - self.pausedFor) - self.startDelay
        else:
            return 0
        
    #dont use this method manually
    def onGameStatusChanged(self, status):
        if status == bf2.GameStatus.Paused:
            self.__pause()
        elif status == bf2.GameStatus.Playing:
            if self.isPaused():
                self.__unpause()
            else:
                self.__start()
        elif status == bf2.GameStatus.PreGame:
            self.__reset()
